
(*
 * ADDBIDIR - Add bidirectional uploads to $DOOR.NAM file
 *            to allow PRODIZ processing of un-announced uploads
 *            under ProDoor.
 *
 * Samuel H. Smith, 3/27/92
 *
 *)

var
   fd:    text;
   line:    string;
   found:   boolean;

begin
   if paramcount <> 2 then
   begin
      writeln('Usage:   addbidir FILELIST FILENAME');
      writeln('Example: addbidir C:\PCB\$DOOR.NAM J:\PLAY\NEWUL.ZIP');
      halt;
   end;

   assign(fd,paramstr(1));
   {$i-} reset(fd); {$i+}
   if ioresult <> 0 then
   begin
      writeln('New ',paramstr(1),' created.');
      rewrite(fd);
      writeln(fd,paramstr(2));
      writeln(fd,'| <unknown>');
      writeln(fd);
      close(fd);
      halt;
   end;

   found := false;
   while not eof(fd) do
   begin
      readln(fd,line);
      if line = paramstr(2) then
      begin
         found := true;
         writeln(line,' already listed in ',paramstr(1));
      end;
   end;

   close(fd);

   if not found then
   begin
      writeln('Adding ',paramstr(2),' to ',paramstr(1));
      append(fd);
      writeln(fd,paramstr(2));
      writeln(fd,'| <unknown>');
      writeln(fd);
      close(fd);
   end;
end.

