' $linesize:132
' $title: 'Alias sub for Maple street version of RBBS'
' $INCLUDE: 'RBBS-VAR.BAS'
'
' $SUBTITLE: 'AliasChk - Checks whether ALIAS exists'
' $PAGE
'
'  SUBROUTINE NAME    -- AliasChk
'
'  INPUT PARAMETERS   --     PARAMETER                    MEANING
'                         WhoFind$                    ALIAS to find
'
'  OUTPUT PARAMETERS  --  WhoFound                    Whether ALIAS found
'                         UserNumFound                Record # of User
'
'  SUBROUTINE PURPOSE --  Validate that ALIAS exists.  Get User Record
'
2257 SUB AliasChk (WhoFind$,WhoFound,UserNumFound) STATIC         'Mpl-ALias
     IF WhoFound = ZTrue THEN EXIT SUB                            'Mpl-Alias2
     CALL BreakFileName (ZMainUserFile$,Drive$,Prefix$,Ext$,ZTrue)    '
     MplTemp = INSTR(ZConfName$," ")                                  '
     IF MplTemp > 0 THEN _                                            '
        MplFileName$ = Drive$ + LEFT$(ZConfName$,MplTemp-1) + "A.DEF" _ '
     ELSE MplFileName$ = Drive$ + ZConfName$ + "A.DEF"                '
     CALL FindIt (MplFileName$)                                       '
     IF NOT ZOK THEN _                                                '
        EXIT SUB                                                      '
CALL OpenWork (7,MplFileName$)
     WhoFound=ZFalse                       'Mpl-Alias2
     MplAlias$ = ""                                                   '
     WHILE MplAlias$ = "" AND NOT EOF(7)                              '
        INPUT #7, MplUserName$, MplTempAlias$                         '
        IF Instr(MplTempAlias$,WhoFind$) > 0 THEN                  'Mpl-Alis2
          ZSubParm = 1
          ZOutTxt$ = ZFG6$ + "Send to "+ MPlTempAlias$ +"([Y]" + ZFG6$ + ",N) " + ZEmphasizeOff$
          Call TGet
           IF ZSubParm = -1 Then _
              EXIT SUB
           IF ZWasQ=0 THEN ZYes = ZTrue
               IF ZYes THEN
                  WhoFound = ZTrue                     'Pe 04/04/92
                  WhoFind$ = MplTempAlias$
                  MplAlias$ = MplUserName$ 
               END IF
          END IF                                                       '
     WEND                                                              '
     CLOSE 7                                                           '
   END SUB                                                             '
59750' $SUBTITLE: 'AliasMpl - Subroutine to Create/Update Alias Info file'
' $PAGE
'
'  SUBROUTINE NAME    -- MplAlias
'
'  INPUT PARAMETERS   --     PARAMETER                    MEANING
'                         ZConfName$                  CONFERENCE NAME
'                         ZOrigUserNameMpl$           USERS - LOG ON NAME
'                         MplAlias$                   USERS - ALIAS NAME
'                         MplStl$                     NULL FIRST TIME IN
'                                                     'STILL' IF ALIAS EXISTS
'                                                        OR REAL NAME
'                         MplFileName$                CONFERENCE ALIAS FILE
'
'  OUTPUT PARAMETERS  --  ZConfName$ ZOrigUserNameMpl$ MplAlias$ MplStl$
'                         MplFileName$
'
'  SUBROUTINE PURPOSE --  TO Read ConfA.DEF and Get Users ALIAS or
'                         Create One
'
     SUB AliasMpl (ZConfName$,ZOrigUserNameMpl$,MplAlias$,MplStl$,MplFileName$) STATIC
'
     IF MplStl$ = "" THEN
        ConfADefFlag = 0
        CALL BreakFileName (ZMainUserFile$,Drive$,Prefix$,Ext$,ZTrue)
        MplFileName$ = Drive$ + ZConfName$ + "A.DEF"
        CALL FindIt (MplFileName$)
        IF ZOK THEN
           ConfADefFlag = ZTrue
        END IF
        IF ConfADefFlag = ZTrue THEN
         CALL OpenWork (7,MplFileName$)
           MplAlias$ = ""
           WHILE MplAlias$ = "" AND NOT EOF(7)
              INPUT #7, MplUserName$, MplTempAlias$
              MplUnl = LEN(MplUserName$)
              IF MplUserName$ = LEFT$(ZOrigUserNameMpl$,MplUnl) THEN
                 MplAlias$ = MplTempAlias$
              END IF
           WEND
           CLOSE 7
        ELSE
           MplAlias$ = "NO CONFA.DEF"
           EXIT SUB
        END IF
     END IF
     CALL GoodAls (ZConfName$,ZOrigUserNameMpl$,MplAlias$,MplStl$,MplFileName$)
     END SUB
'
'
' $SUBTITLE: 'GoodAls - Subroutine to Make Sure Alias Good'
' $PAGE
'
'  SUBROUTINE NAME    -- GoodAls
'
'  INPUT PARAMETERS   --     PARAMETER                    MEANING
'                         ZConfName$                  CONFERENCE NAME
'                         ZOrigUserNameMpl$           USERS - LOG ON NAME
'                         MplAlias$                   USERS - ALIAS NAME
'                         MplStl$                     NULL FIRST TIME IN
'                                                      'STILL' IF ALIAS EXISTS
'                                                         OR REAL NAME
'                         MplFileName$                CONFERENCE ALIAS FILE
'
'  OUTPUT PARAMETERS  --  ZConfName$ ZOrigUserNameMpl$ MplAlias$ MplStl$
'                         MplFileName$
'
'  SUBROUTINE PURPOSE --  To Read ConfA.DEF and see if Users ALIAS is
'                         Aready in Use or a Real Name
'
     SUB GoodAls (ZConfName$,ZOrigUserNameMpl$,MplAlias$,MplStl$,MplFileName$) STATIC
'
     IF MplAlias$ = "" THEN
        MplSfnSln$ = ZSysopFirstName$+" "+ZSysopLastName$
        ZOutTxt$ = "Do you" +MplStl$+ " want to use an Alias? (Y,[N])"
        ZSubParm = 1
        CALL TGet
        IF ZYes THEN
           ABFlg$ = ""
           ZOutTxt$ = "Enter Alias (31 Char. Max.) "
           ZSubParm = 1
           CALL TGet
           CALL AllCaps (ZUserIn$)
           IF ZUserIn$ = "" OR INSTR(SPACE$(31),ZUserIn$) > 0 THEN
              ZUserIn$ = ""
              ABFlg$ = "Alias Must NOT be Blank"
           END IF
           IF LEN(ZUserIn$) > 31 THEN
              ZUserIn$= ""
              ABFlg$ = "Length Must NOT Exceed 31 Characters"
           END IF
           IF ZUserIn$ = "SYSOP" OR ZUserIn$ = MplSfnSln$ THEN
              ZOutTxt$ = CHR$(7)+CHR$(7)
              ZOutTxt$ = ZOutTxt$ + "Wrong Answer! Alias Request Denied!"
              ZOutTxt$ = ZOutTxt$ + CHR$(13) + "Contact Sysop for Alias Retry"
              CALL QuickTPut (ZOutTxt$,2)
              MplAlias$ = ZOrigUserNameMpl$+CHR$(250)
              ZActiveUserName$ = ZOrigUserNameMpl$+CHR$(250)
              ZFirstName$ = ZOrigUserNameMpl$+CHR$(250)
           ELSE
              CALL OpenWork (7,MplFileName$)
              WHILE ABFlg$ = "" AND NOT EOF(7)
              INPUT #7, MplUserName$, MplTempAlias$
              IF ZUserIn$ = MplUserName$ THEN
                 ABFlg$ = " is a Real User"
              ELSE
                 IF ZUserIn$ = MplTempAlias$ THEN
                    ABFlg$ = " has Already been Used"
                 END IF
              END IF
              WEND
              CLOSE 7
              IF ABFlg$="" THEN
                 MplAlias$ = ZUserIn$
                 ZActiveUserName$ = ZUserIn$
                 ZFirstName$ = ZUserIn$
              ELSE
                 ZOutTxt$="Sorry "+ZFirstName$+" but "+ZUserIn$+ABFlg$
                 CALL QuickTPut (ZOutTxt$,1)
                 MplStl$ = " still"
                 MplAlias$ = ""
              END IF
          END IF
        ELSE
           MplAlias$ = ZOrigUserNameMpl$
        END IF
        IF MplAlias$ <> "" THEN
           CLOSE 2
           FOR I = 1 TO LEN(MplAlias$)
              IF MID$(MplAlias$,I,1)=CHR$(34) THEN MID$(MplAlias$,I,1)=CHR$(39)
           NEXT I
           Call OpenWorkA (MplFileName$)
           WRITE #2, ZOrigUserNameMpl$, MplAlias$
           CLOSE 2
        END IF
      ELSE
        ZActiveUserName$ = MplAlias$
        ZFirstName$ = MplAlias$
      END IF
      END SUB
