;Door Control file
;-----------------
;
;Sysopfirst: Specifies the first name of the sysop as it will be shown to
;            the users.
;
;SysopLast:  Specifies the last name of the sysop as it will be shown to
;            the users.
;
;BBSName:    Specifies the name of the bbs as it will be shown to users.
;
;Mono:       Will disable color on the local side. (Necessary if you are
;            running a monochrome system)
;
;BBSType:    Specifies the type of bbs software under which this door program
;            will be run. Valid bbs types include:
;
;                     RBBS - Rbbs-Pc version 16.1+ (uses DORINFOx.DEF)
;                    QUICK - Quickbbs; Uses DORINFOx.DEF (same as above)
;                    PCB12 - Pcboard version 12 (note: see COMPORT note below)
;                     WWIV - WWIV bbs (uses chain.txt)
;                  PHOENIX - Phoenix bbs
;                  WILDCAT - Wildcat bbs
;
;ComPort:    For bbs types that do not have the com-port contained in their
;            door information files (such as PCBOARD-12), you will have to
;            specify the com-port. Simply put the port number (i.e. 1,2,etc)
;            not the whole word COM1.
;
;Internal:   Selecting this option will cause doordriver to use it's internal
;            buffered comm routines. If you do not have a fossil, it is a good
;            idea to use this option.
;
;Maxtime:    The maxtime parameter will allow you to specify a maximum time
;            per session that a user may be in the door. (i.e. if you
;            specified 30 minutes, then if the user had 60 mins left, he could
;            only play for 30 mins)
;
;Quiet:      If specified, the door will strip out all ^G characters from
;            the local side.
;
;Status:     Specify "ON" if you wish the status line to appear at the bottom
;            of "OFF" if you wish it to be disabled.
;
;Statfore:   The foreground color of the status line (default 0)
;
;Statback:   The background color of the status line (default 7)
;
;Foreground: Specifies default foreground color (default 7)
;
;Background: Specifies default background color (default 0);
;
;Color1:     Tells doordriver to select ANSI graphics when a "1" is passed
;            in the graphics parameter of the DORINFOx.DEF. From what I
;            understand, FORCE and QUICKBBS require this option set although
;            RBBS should not.
;
;43Line:     The 43LINE option will instruct doordriver to load in the EGA
;            43-line mode. (You MUST have an EGA adapted for this option). The
;            enhanced screen allows the local sysop to see much more infor-
;            mation on the screen.
;
;25Exit:     The 25EXIT option will tell DoorDriver to switch back to the 25
;            line mode when doordriver is completed. This option is only
;            useful when the above 43LINE option is used. If 25EXIT is not
;            specified and 43LINE is, then doordriver will exit to DOS in
;            the 43-line mode.
;
;ReMapFore:  The REMAPFORE parameter allows you to "remap" doordrivers color.
;            This allows you to substitue in one color for another (i.e.
;            you could substitute in GREEN for all instances of BLUE). The
;            REMAPFORE parameter effects only the FOREGROUND color. The
;            REMAPBACK command below handles the background colors. When a
;            color is substituted, it effects both the LOCAL user and the
;            REMOTE user. REMAPFORE's syntax is below:
;
;                       Syntax:  REMAPFORE <color1> <color2>
;                      Example:  REMAPFORE 14 15
;
;            The <color> parameters are numeric codes for colors which are
;            listed on a table below. The example will substitue white
;            (color 15) in for yellow (color 14)
;
;                0 - Black   4 - Red       8 - DarkGray    12 - Lightred
;                1 - Blue    5 - Magenta   9 - LightBlue   13 - LightMagenta
;                2 - Green   6 - Brown    10 - LightGreen  14 - Yellow
;                3 - Cyan    7 - LgtGray  11 - LightCyan   15 - White
;
;RemapBack:  The Remapback command is similar to the remapfore command, but
;            it effects background colors instead of foreground colors. The
;            syntax is identical except that only colors 0-7 are available
;            for background.
;
;-----------------------------------------------------------------------------
;Parameters used by the galactic warzone sector generator on initialization:
;
;NumSectors: New with version 7.0 and up of galactic warzone, the sysop may
;            designate how many sectors he wishes the game to have. This is
;            specifiable from 500-5000 sectors. Each sector take 34 bytes of
;            ram (in addition to the 340k required for other parts of GW).
;            (i.e. For a 3000 sector universe, 340,000+(3000*34)=442k of
;            ram required). NOTE: THIS PARAMETER ONLY EFFECTS THE INITIALIZ-
;            ATION OF THE GAME - THE NUMBER OF SECTORS CAN NOT BE CHANGED
;            "ON THE FLY".
;
;CabalBase:  This parameter is used to set up the sector in which the cabal
;            will operate their base. Although it is possible to reset this
;            parameter while the game is in progress, it is not suggested.
;            NOTE: THE SECTOR NUMBER MAY NOT BE GREATER THAN THE NUMBER OF
;            SECTORS LISTED ABOVE.
;
;Deadend:    Specifies the number of dead-end sectors that will be created
;            in the game. Dead ends offer players nice places to hide
;            in and make excellent bases. If you wish to create more dead
;            ends, it can be done through the internal editor
;-----------------------------------------------------------------------------
;
SYSOPFIRST SCOTT
SYSOPLAST BAKER
BBSNAME THE NOT-YET-NAMED BBS
;
;       ::::------- Put your bbs type here! Select from those listed above
;       ::::
;       \/\/
BBSTYPE RBBS
;
;                   If you are using a bbs type that doesn't provide the com
;        ::-------- port num in it's door information file (such as pcb-12),
;        \/         then uncomment this line and put your com port here.
;COMPORT 1
;
;
;INTERNAL
;                   Uncomment this line if you are running a monochrome
;  ::-------------- system on the local side.
;  \/
;MONO
;QUIET
STATUS ON
STATFORE 0
STATBACK 7
FOREGROUND 7
BACKGROUND 0
;                   Uncomment this if GW doesn't give color output to users
;  ::-------------- who have color (ansi) selected.
;  \/
;COLOR1
;
;43LINE
;25EXIT
;
;The following parameters are used by the GW sector initializer when it
;creates the sector file:
;
NUMSECTORS 2000
CABALBASE 1137
DEADEND 20
;