echo off
:  *************************************************************
:  * Batch program to initiate GT and process scheduled events *
:  *************************************************************
:
:
:  Allowed Syntax:
:
:     GT parm1 parm2
:
:  Parameter Definition:
:
:     HOST    =   Invoke GT in the Host mode (otherwise terminal mode)
:     LOGGER  =   Set logger option ON (for host execution only)
:
:  Special Considerations:
:
:     For Host mode operation, scheduled events may be initiated via the
:     "QUIT n" command in SCHEDULE.BBS.  The "n" parameter will be passed
:     back to this batch command processor in the ERRORLEVEL variable.
:     This variable is value checked to determine if an event is to be
:     initiated.  All events are initiated from this processor as an
:     external batch file command.  
:
:     WARNING: It is important that each batch file called as a scheduled
:     event, reinitiates GT in the Host mode upon completion.  If this is
:     not enforced the system will not recycle after the event has completed.
:     This is very important!
: 
:  Begin {GT processor}
:
cls
:
:    Set up default directory
:
c:
cd \BULLETIN
:
:    If HOST parameter not specified then,
:
if host==%1 goto gthost
if HOST==%1 goto gthost
if host==%2 goto gthost
if HOST==%2 goto gthost
:
:      Begin {terminal mode}
:
:        Initiate GT in Terminal mode;
:
trace Invoking GT In Terminal Mode
gt1300 /M
:
:        And exit batch program;
:
goto exit
:
:      End; {terminal mode}
:
:    Else, Initiate GT in Host mode
:
:gthost
:
:      Begin {host mode}
:
:        If logger parameter not specified,
:
if logger==%1 goto logon
if LOGGER==%1 goto logon
if logger==%2 goto logon
if LOGGER==%2 goto logon
:
:          then initiate GT Host without logger option
:
trace Invoking GT In Host Mode
gt1300 /M c:\gtscript\host.scr
goto chkevnt
:
:        Else, initiate GT with logger option specified
:
:logon
trace Invoking GT In Host Mode (Logger ON)
gt1300 /P /M c:\gtscript\host.scr
:
:        Check for GT return code for indication of scheduled event
:        (Note: errorlevel checking must be performed in decreasing
:               order as far as value, {i.e. 9,8,7,6,...,1,0}.  DOS
:               is real stupid when it comes to errorlevel checking!)
:
:           Case ERRORLEVEL of
:
:             '5': Reboot under native DOS
:             '4': Reboot under DoubleDOS
:             '3': Execute NetMail transfers
:             '2': Execute daily maintenance
:             '1': Execute monthly maintenance
:
:           Else, Terminate GT
:
:chkevnt
if ERRORLEVEL==5 goto native
if ERRORLEVEL==4 goto ddos
if ERRORLEVEL==3 goto netmail
if ERRORLEVEL==2 goto dlymaint
if ERRORLEVEL==1 goto mthmaint
goto exit
:
:           '5': Reboot under Native Dos
:
:native
swapauto g y
:
:           '4': Reboot under DoubleDOS
:
:ddos
swapauto d y
:
:           '3': Execute NetMail transfers
:
:netmail
mail xxxx-yyyy 23 24
:
:           '2': Execute daily maintenance
:
:dlymaint
maint daily
:
:           '1': Execute monthly maintenance
:
:mthmaint
maint monthly
:
:      End; {host mode} 
:
:
:  End; {GT processor}
:
:exit
cd\
cls
