#define LINT_ARGS
#pragma check_stack(off)                  // We dont need stack checking
#pragma pack(1)                           // All structures must be packed

#include <stdio.h>                        // C standard header file
#include "compiler.h"                     // Turbo Or Microsoft?      GAPCDR

#ifdef TC                                 // TC malloc header
   #include "alloc.h"
#else
   #include "malloc.h"                    // MS malloc header
#endif

#include "gapcdr.h"                       // header file for GAPCDR   GAPCDR
#include "gapwin.h"                       // header file for GAPWIN

main(int argc,char *argv[])
   {
   int bobo;                              // to keep track of errors
   FILE *doorcnf;                         // file pointer for cnf file
   int KEY;
   char config_name[13];
   short ch;
   unsigned char early_exit=0;
   char instring[10];
					  // Get config filename
   config_name[0]='\0';
   if (argv[1]!=NULL) strcpy(config_name,argv[1]);
   else strcpy(config_name,"WINDOW.CNF");

   // OPEN GAP FILES AND INIT GAPCDR, NO ERROR CHECKING FOR DEMO.
   //
   doorcnf = read_cnf(config_name);      // read door configuration file
   init_door();                          // initialize the door
   fclose(doorcnf);
   bobo = read_doorsys();                // read the system file
   if (bobo) early_exit=1;

   if (!early_exit)
      if ((!init_window_system())||(!check_color())) early_exit=1;

   if (!early_exit)
      {
      clear_scrn();
      // SETUP ALL THE WINDOWS FOR THE DEMO. MAX TEN WINDOWS FOR NOW.
      //
      // WIN#, X1, Y1, X2, Y2, STYLE TYPE, FOREGROUND, BACKGROUND,
      // TITLE BACKGROUND, TITLE ON, TITLE.
      //
      setup_window(1,10, 5,60,19,1,  A_CYAN,   A_BLUE,  A_BRED,1,"Welcome To The GAP Windowing Toolkit Demo");
      setup_window(2,15,10,65,18,2,   A_RED,   A_CYAN,  A_BLUE,1,"Example Of Overlapping Save/Restore");
      setup_window(3,20, 5,50,17,3,A_YELLOW,    A_RED, A_BLACK,0,"Example Of A 3-D Shaded Window");
      setup_window(4,25, 3,70, 8,3,  A_CYAN,   A_BLUE,  A_CYAN,0,"Example Of A 3-D Shaded Window");
      setup_window(5,45,12,65,21,1,  A_BLUE,   A_CYAN,  A_BLUE,1,"Window Style One");
      setup_window(6,10,12,30,18,2,  A_CYAN,A_MAGENTA,A_YELLOW,1,"Window Style Two");
      setup_window(7, 5, 5,55,17,2,  A_CYAN,   A_BLUE,  A_BRED,1,"This Single Line Is Window Type 2");
      setup_window(8, 7, 7,75,21,2,  A_BLUE,    A_RED,A_YELLOW,1,"Input Routines");

      // RESET TO FULL SCREEN AND SET BACKGROUND COLOR, SHOW INITIAL INFO
      //
      reset_windows();
      ansiback(A_BLACK);
      out_xyc(5,5,A_YELLOW,   "     The GAPWIN Door Development Window-ing Toolkit Ver 1.2");
      out_xyc(5,7,A_BCYAN,    "   (C) Copyright 1990 By Jeffrey Donovan. All Rights Reserved");
      out_xyc(5,9,A_BMAGENTA, "               This Demonstration Program Was ");
      out_xyc(5,10,A_BMAGENTA,"      Written Using Standard GAPCDR And GAPWIN Libraries.");
      out_xyc(5,12,A_BGREEN,  "     For Further Information On The GAPWIN Library Contact ");
      out_xyc(5,13,A_BGREEN,  " Jeffrey Donovan At The Bulls & Bears BBS (805) 962-8206 To 2400");
      out_xyc(5,17,A_RED,     "                     Press Any Key...");
      while (!getakey());
      clear_scrn();       // <-ONLY USE CLEAR_SCRN WHEN NO CURRENT WINDOW DEFINED
			  //   OTHERWISE USE CLEAR_WINDOW

      // MAKE FIRST WINDOW AND SHOW TEXT
      //
      text_window(1);
      out_xyc(2,2,A_BCYAN,"This is a small demonstration of the GAP ");
      out_xy(2,3,"DEVELOPERS WINDOW toolkit. The purpose is to");
      out_xy(2,4,"provide a comprehensive set of text level");
      out_xy(2,5,"windowing tools compatable with  both ANSI.SYS");
      out_xy(2,6,"and GAPCDR libraries.");
      out_xy(2,8,"First, lets investigate a powerfull feature.");
      out_xy(2,9,"Dynamic screen saves for profesional windowing.");
      out_xy(2,10,"We will now overlap another window on top");
      out_xy(2,11,"of this window.");
      out_xyc(12,13,A_BGREEN,"Press Any Key To Continue..");

      while (!getakey());

      // NOW SAVE BEHIND WINDOW 2, AND THEN MAKE WINDOW 2 AND DISPLAY TEXT
      //
      save_behind_window(2);
      text_window(2);
      out_xyc(2,2,A_BLACK,"Now, by this time, we have saved the screen");
      out_xy(2,3,"behind this window. Press another key and we");
      out_xy(2,4,"will release this screen and restore the ");
      out_xy(2,5,"previous screen.");
      out_xy(18,7,"Press Any Key");
      while (!getakey());

      // NOW RESTORE SCREEN BEHIND WINDOW 2, RESTORE COORDS TO WINDOW ONE,
      // CLEAR WINDOW 1 AND DISPLAY TEXT
      //
      restore_behind_window(2);
      restore_text_window(1);
      clear_window();
      out_xyc(2,2,A_BCYAN,"We just restored this window and cleared it.");
      out_xy(2,3,"Next, lets look at some other types of ");
      out_xy(2,4,"windows. First, We will change the background");
      out_xy(2,5,"so to highlight the effects of 3-D Shading.");
      out_xyc(12,12,A_BGREEN,"Press Any Key...");
      while (!getakey());

      // NOW RESET TO GLOBAL SCREEN, CLEAR TO BACK ALL WHITE AND MAKE
      // FIRST 3-D SHADED WINDOW NUM 3
      //
      reset_windows();
      ansiback(A_WHITE);
      clear_window();
      text_window(3);
      out_xyc(6,1,A_BCYAN,"A 3-D Shaded Window");
      out_xyc(2,3,A_YELLOW,"Well, heres an effectice 3-d");
      out_xy(2,4,"shaded window. Lets put the ");
      out_xy(2,5,"three different types of");
      out_xy(2,6,"windows.");
      out_xyc(2,12,A_BLUE,"Press Any Key..");
      while (!getakey());

      // NOW CONTINOUSLY SAVE CONTENTS BEHIND WHILE POPPING OTHER 3-D
      // SHADED WINDOWS.
      //
      save_behind_window(4);
      text_window(4);
      out_xyc(2,2,A_YELLOW,"This Is Window Style Three");
      out_xy(2,3,"The title toggle is turned off here.");
      out_xy(2,4,"Actually the title toggle is ignored");
      out_xy(2,5,"because on shaded windows it looks sloppy.");

      save_behind_window(5);
      text_window(5);

      save_behind_window(6);
      text_window(6);
      out_xyc(3,4,A_BCYAN,"Press Any Key..");
      while (!getakey());

      // NOW RESTORE CONTENTS BEHIND THOSE WINDOWS.
      //
      restore_behind_window(6);
      restore_behind_window(5);
      restore_behind_window(4);
      restore_text_window(3);

      // NOW LETS SHOW ANOTHER WINDOW AND SOME OF THE CLEAR LINE FUNCTIONS
      //
      ansiback(A_BLACK);
      reset_windows();
      clear_window();
      text_window(7);
      out_xycb(2,2,A_YELLOW,A_RED,"Here We Set XY, color, bacground, AND write the");
      out_xycb(2,3, A_BLUE,A_CYAN,"text all in One Command");
      out_xycb(2,5,A_BRED,A_BLUE,"Here we set XY, color, and write the text in");
      out_xy(2,6,"one command.");
      out_xycb(2,8,A_YELLOW,A_BLUE,"Notice also how lines are clipped in windows asss we over");
      out_xy(2,9,"See? We overwrote the line and the window");
      out_xy(2,10,"clipped it.");
      out_xyc(15,11,A_BMAGENTA,"Press Any Key...");
      while(!getakey());


      // NOW LETS LOOK AT SOME INPUT ROUTINES
      //
      save_behind_window(8);
      text_window(8);
      out_xyc(2,2,A_BCYAN,"Now, lets look at some input routines. This will require some");
      out_xy(2,3,"interaction from you.");
      out_xy(2,5,"The GAPWIN input routines work fairly much like GAPCDR input");
      out_xy(2,6,"routines, but have been slightly enhanced.");
      out_xy(2,8,"The important thing to note is that you MUST use the GAPWIN");
      out_xy(2,9,"functions instead of GAPCDR functions. This is because the GAPCDR");
      out_xy(2,10,"functions do not keep track of window coordinates and colors.");
      out_xyc(25,13,A_YELLOW,"Press Any Key..");
      while (!getakey());


      // HERES A FASTER WAY TO CLEAR SCREEN BY JUST CLEARING LINES WE
      // HAVE WRITTEN ON. MORE PROGRAMMING EFFORT, BUT FASTER RESULTS.
      //
      clear_line(2);clear_line(3);clear_line(5);
      clear_line(6);clear_line(8);clear_line(9);
      clear_line(10);clear_line(13);

      out_xyc(2,2,A_BCYAN,"First, we DO NOT call the GAPCDR function empty() before");
      out_xy(2,3,"input. Instead we set the first element of the string to NULL.");
      out_xy(2,4,"However, if you pass a string that already contains data to the");
      out_xy(2,5,"GAPWIN input functions, the function will print out the string,");
      out_xy(2,6,"and position the cursor at THE END of the string for editing.");
      out_xy(2,7,"Notice also the input routines DO NOT allow overun.");

      out_xyc(2,9,A_YELLOW,"Enter A 10 Char String ->");
      ansiback(A_BLUE);
      clear_line_from_to(9,28,38);
      instring[0]='\0';
      wget_string_xy(28,9,instring,10);

      out_xycb(2,11,A_YELLOW,A_RED,"Now Re-Edit That String->");
      ansiback(A_BLUE);
      clear_line_from_to(11,28,38);
      wget_string_xy(28,11,instring,10);

      out_xycb(42,10,A_YELLOW,A_RED,"String = ");wansi(A_BLUE);out_text(instring);
      out_xycb(25,13,A_YELLOW,A_RED,"Press Any Key..");

      while (!getakey());


      // NOW RESTORE WINDOW 7 AND CONCLUDE THE DEMO
      //
      restore_behind_window(8);
      restore_text_window(7);
      clear_window();

      // CLEAR ENITRE SCREEN AND EXIT.
      //
      out_xyc(5,5,A_YELLOW,"This Concludes The Window-ing Demo...");
      out_xy(7,7,"Press Any Key To Return To BBS...");
      while (!getakey());
      ansiback(A_BLACK);
      clear_scrn();

      close_window_system();              // close window system
      }
   leave(0);                              // must exit properly!
   }


